// nnc4hdus.h Copyright (C) 2008 񁗕ҏW 

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *  This Program is free software; you can redistribute it and/or modify     *
 *  it under the terms of the GNU General Public License as published by     *
 *  the Free Software Foundation; either version 2, or (at your option)      *
 *  any later version.                                                       *
 *                                                                           *
 *  This Program is distributed in the hope that it will be useful,          *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             *
 *  GNU General Public License for more details.                             *
 *                                                                           *
 *  You should have received a copy of the GNU General Public License        *
 *  along with GNU Make; see the file COPYING.  If not, write to             *
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.    *
 *  http://www.gnu.org/copyleft/gpl.html                                     *
 *                                                                           *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef NNC4HDUS_H
#define NNC4HDUS_h

#define SA_E2PROM       (0xA8)
#define SA_ASIE5606     (0x5A)
#define SA_ASIE5606_NEW (0x4A)
#define SA_TUNER        (0x20)

#define TRANSFER_SIZE (0x10000)
#define NUM_CONTEXT (16)
#define NUM_BUFFER (64)
#define NUM_CHECKPACKET (8)
#define PACKET_LENGTH (188)
#define BUFFER_ADDITION (PACKET_LENGTH * NUM_CHECKPACKET)

typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned long ulong;

extern bool interrupted;
extern bool verbose;

double getTime ();
void miliSleep ( int ms );

class UsbDevice {
  UsbDevice ( const UsbDevice & );
public:
  void* husb;
  UsbDevice () : husb( 0 ) {};
  ~UsbDevice ();
  operator bool () { return husb != 0; }

  bool Open ( ushort vendor, ushort product ); 

  bool vendorRequest (
    ushort wLength, uchar* data, uchar bRequest,
    uchar v0 = 0, uchar v1 = 0, uchar v2 = 0, uchar v3 = 0 );
};

class TSPointer {
public:
  uchar* ptr;
  int len;

  TSPointer ( uchar* _ptr, int _len ) : ptr( _ptr ), len( _len ) {}

  static bool isPacketTop ( uchar* p, int n );
  bool resync ( TSPointer& rem );
};

class RecContext {
  TSPointer remainder;
  bool lock;
public:
  UsbDevice usb;
  double time;
  FILE* output;
  uchar* recvBuf;
  int tunerID;

  RecContext () : remainder( 0, 0 ), lock( false ),
                  time( 10 ), output( 0 ), recvBuf( 0 ), tunerID( 0 ) {}
  ~RecContext () {
    if ( recvBuf != 0 )
      delete[] recvBuf;
  }

  bool allocRecvBuf () {
    recvBuf = new uchar [TRANSFER_SIZE * NUM_BUFFER + BUFFER_ADDITION];
    return recvBuf != 0;
  }
  bool out ( uchar* data, int len );
  void syncOut ( uchar* buf, ulong size );
};

void rec ( RecContext* rc );

#endif
