/*
 uusbd.dllhdus̑̂Œuusbd.sysɃANZX 
*/

#include <stdio.h>
#include <windows.h>
#include <setupapi.h>
#include <tchar.h>
#include <initguid.h>
#include <ddk/usb.h>

#include "uusbdioctl.h"

#include "uusbd.h"

typedef struct {
  HANDLE handle;
  TCHAR name[ MAX_PATH ];
} UUSBDevice;

// {69910468-8802-11d3-ABC7-A756B2FDFB29} for UUSBD.SYS 
DEFINE_GUID(GUID_CLASS_UUSBD, 
0x69910468, 0x8802, 0x11d3, 0xab, 0xc7, 0xa7, 0x56, 0xb2, 0xfd, 0xfb, 0x29);

BOOL
GetDeviceName ( HDEVINFO hDevInfo, LPGUID pGuid, int index, TCHAR* name )
{
  BOOL ret = FALSE;
  SP_INTERFACE_DEVICE_DATA deviceData;
  deviceData.cbSize = sizeof( SP_INTERFACE_DEVICE_DATA );
  if ( SetupDiEnumDeviceInterfaces( hDevInfo, 0, pGuid, index, &deviceData ) ) {
    ULONG requiredLength;

    SetupDiGetDeviceInterfaceDetail( hDevInfo, &deviceData, NULL, 0, &requiredLength, NULL );

    DWORD err = GetLastError();
    if ( err == ERROR_INSUFFICIENT_BUFFER ) {
      PSP_INTERFACE_DEVICE_DETAIL_DATA pDeviceData =
        (PSP_INTERFACE_DEVICE_DETAIL_DATA)malloc( requiredLength );
      if ( pDeviceData != 0 ) {
        pDeviceData->cbSize = sizeof( SP_INTERFACE_DEVICE_DETAIL_DATA );
        if ( SetupDiGetInterfaceDeviceDetail( hDevInfo, &deviceData, pDeviceData,
                                              requiredLength, NULL, NULL ) ) {
          _tcscpy( name, pDeviceData->DevicePath ); //, pDeviceData->cbSize );
          ret = TRUE;
        }
        free( pDeviceData );
      }
    }
  }
  return ret;
}

static BOOL
OpenDevice ( UUSBDevice* ud, USHORT vendor, USHORT product, bool verbose )
{
  ud->handle = INVALID_HANDLE_VALUE;

  LPGUID pGuid = (LPGUID)&GUID_CLASS_UUSBD;

  HDEVINFO hDevInfo =
    SetupDiGetClassDevs( pGuid, NULL, NULL, (DIGCF_PRESENT | DIGCF_INTERFACEDEVICE) );

  BOOL ret = FALSE;
  if ( hDevInfo != INVALID_HANDLE_VALUE ) {
    for ( ULONG i = 0; GetDeviceName( hDevInfo, pGuid, i, ud->name ); i++ ) {
      if ( verbose )
        fprintf( stderr, "device: %s", ud->name );
      if ( _tcstoul( ud->name+12, 0, 16 ) != vendor || _tcstoul( ud->name+21, 0, 16 ) != product ) {
        fputs( " ...NC.\n", stderr );
        continue;
      }
      ud->handle = CreateFile( ud->name, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE,
                               NULL, OPEN_EXISTING, 0, NULL );
      if( ud->handle != INVALID_HANDLE_VALUE ) {
        fputs( " ...OK.\n", stderr );
        ret = TRUE;
        break;
      }
      fputs( " ...busy.\n", stderr );
    }
    SetupDiDestroyDeviceInfoList( hDevInfo );
  }
  fputc( '\n', stderr );
  return ret;
}

USB_Handle
OpenDevice ( USHORT vendor, USHORT product, bool verbose )
{
  UUSBDevice* ud = new UUSBDevice;
  if ( ud && !OpenDevice ( ud, vendor, product, verbose ) ) {
    delete ud;
    ud = 0;
  }
  return ud;
}

void
CloseDevice ( USB_Handle ud )
{
  if ( ud ) {
    CloseHandle( ((UUSBDevice*)ud)->handle );
    delete (UUSBDevice*)ud;
  }
}

HANDLE
OpenPipe ( USB_Handle ud, UCHAR interface_num, UCHAR pipe_num )
{
  TCHAR name[ MAX_PATH+100 ];
  _stprintf( name,"%s\\if%03dpipe%03d", ((UUSBDevice*)ud)->name, interface_num, pipe_num );
  return CreateFile( name, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE,
                     NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL );
}

int
VendorRequest (
  USB_Handle ud, UCHAR bRequest, USHORT wValue, USHORT wIndex, USHORT wLength, char *data )
{
  PARAM_VENDOR_REQUEST param;
  param.Function = URB_FUNCTION_VENDOR_DEVICE;
  param.TransferFlags = USBD_SHORT_TRANSFER_OK;
  param.ReservedBits = 0;
  param.Request = bRequest;
  param.Value = wValue;
  param.Index = wIndex;
  DWORD size;
  return DeviceIoControl( ((UUSBDevice*)ud)->handle,
    IOCTL_UUSBD_VENDORREQUEST_IN, &param, sizeof( param ), data, wLength, &size, NULL );
}
